'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _rxjs = require('rxjs');

require('rxjs/add/observable/throw');

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loop = function loop(sources) {
  var hashMap = new Map();
  return _rxjs.Observable.interval(60000).mergeMap(function () {
    return _rxjs.Observable.of.apply(_rxjs.Observable, (0, _toConsumableArray3.default)(sources)).concatMap(function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(source) {
        var feedRawData;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _isomorphicFetch2.default)(source.url);

              case 2:
                _context.next = 4;
                return _context.sent.text();

              case 4:
                feedRawData = _context.sent;
                return _context.abrupt('return', (0, _extends3.default)({}, source, { feedRawData: feedRawData }));

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }()).filter(function (feed) {
      var hash = (0, _md2.default)(feed.feedRawData);
      if (hashMap[feed.url] === hash) {
        return false;
      }
      hashMap[feed.url] = hash;
      return true;
    }).catch(function (error) {
      console.error('fetch failure : ' + error.message); // TODO 如何向外抛出错误
      return _rxjs.Observable.of(null);
    });
  });
};

exports.default = loop;